//+------------------------------------------------------------------+
//|                                                     T3Signal.mqh |
//|                                                    2011, etrader |
//|                                             http://efftrading.ru |
//+------------------------------------------------------------------+
#property copyright "2011, etrader"
#property link      "http://efftrading.ru"
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
#include <Expert\ExpertSignal.mqh>
#define INDICATOR_T3_FILENAME "T3.ex5"
#property tester_indicator INDICATOR_T3_FILENAME
#include <Expert\MySignals\BasedOnIndicatorExpertSignal.mqh>
// wizard description start
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=Signal based on T3 indicator                               |
//| Type=SignalAdvanced                                              |
//| Name=T3                                                          |
//| Class=CT3                                                        |
//| Page=                                                            |
//| Parameter=T3Period,int,14,period of T3                           |
//| Parameter=b_,double,70,coefficient x100                          |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
// wizard description end
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|   CT3                                                       |
//| :               |
//|             T3                                         |
//|            http://www.mql5.com/ru/code/424                       |  
//+------------------------------------------------------------------+
class CT3: public CBasedOnIndicatorExpertSignal{
  private: 
   int m_T3Period;   //  T3                      
   double m_b_;      // x100                          

  public:
   virtual int       ShortCondition();      //   
   virtual int       LongCondition();       //   
   virtual void      FillParameters();      //    m_parameters
//---     T3                      
   void              T3Period( int passedvalue ){ m_T3Period = passedvalue;}  
//---   x100                          
   void              b_( double passedvalue ) { m_b_ = passedvalue;}  
};


//+------------------------------------------------------------------+
//|                      |
//| INPUT:                                                        |
//| OUTPUT:                                                       |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
void CT3::FillParameters(void){
//---   3 -  
  ArrayResize(m_parameters, 3 );
//---  
  m_parameters[0].type         = TYPE_STRING;      
  m_parameters[0].string_value = INDICATOR_T3_FILENAME; 
//---     T3                      
  m_parameters[1].type         = TYPE_INT;      
  m_parameters[1].integer_value = m_T3Period;
//---   x100                          
  m_parameters[2].type         = TYPE_DOUBLE;      
  m_parameters[2].double_value= m_b_; 
}

//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CT3::ShortCondition(){
//---      0
//---       
   if( Close(1) < m_indicator.GetData( 0, 1 )  && Close(2) >= m_indicator.GetData(0, 2 ) )   return( 100 );
//---      
   return(0); 
}


//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CT3::LongCondition(){
//---      0
//---        
   if( Close(1) > m_indicator.GetData( 0, 1 )   &&  Close(2) <= m_indicator.GetData(0, 2 ) )   return( 100 );
//---      
   return(0); 
}

//+------------------------------------------------------------------+